package be.authtest.vaadin.ejb;

import java.security.Principal;
import java.util.List;

import javax.annotation.Resource;
import javax.annotation.security.RolesAllowed;
import javax.ejb.SessionContext;
import javax.ejb.Stateless;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;
import javax.persistence.TypedQuery;

import org.jboss.security.annotation.SecurityDomain;

import be.authtest.vaadin.entity.LBSPlayer;




/**
 * @author LDK
 */
@Stateless
@SecurityDomain(value="GoogleLogin")
@RolesAllowed("user")
public class AuthService {

	@Resource
	SessionContext ctx;
	
	@PersistenceContext(unitName="frontDS")
	protected EntityManager em;
	
	public AuthService() throws Exception {
		super();
	}

	public String myMethod() {
		return this.ctx.getCallerPrincipal().toString();
	}

    public String getSecurityInfo() {
        // Session context injected using the resource annotation
        Principal principal = this.ctx.getCallerPrincipal();
        return principal.toString();
    }
	
	public List<LBSPlayer> allRecords() {
		TypedQuery<LBSPlayer> q = this.em.createQuery("SELECT P from LBSPlayer P", LBSPlayer.class);
		List<LBSPlayer> records = q.getResultList();
		return records;
	}

	public List<LBSPlayer> findByPersonalId(String personalId) {
		TypedQuery<LBSPlayer> q = this.em.createQuery("SELECT P from LBSPlayer P where P.personalId=:personalId", LBSPlayer.class);
		List<LBSPlayer> records = q.setParameter("personalId", personalId).getResultList();
		return records;
	}

}

